/*			FENSTER.H V 2.0
		(c) 1996 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen	*/

#if  !defined( FENSTER_H )
#define FENSTER_H


/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <vdi.h>
#include <portab.h>
/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */



/* Auflsungsstruktur */
/* Lnge der Struktur: 86 Bytes */

typedef struct
{
	char	name[33];				/* Name der Auflsung */
										/* Fr Nicht-C-Programmierer: */
										/* der Offset der nchsten Variablen */
										/* zum Strukturstart betrgt 34 Bytes */
	int	mode;						/* Auflsungsart (siehe ICB.H) */
	int	bypl;						/* Bytes pro Zeile */
	int	planes;					/* Anzahl Planes */
	unsigned int	colors;		/* Anzahl Farben */
	int	hc_mode;					/* Hardcopy-Modus */
	int	max_x, max_y;			/* maximale x- und y-Koordinate */
	int	real_x, real_y;		/* reale max. x- und y-Koordinate */
										/* folgende Variablen sollten nicht */
										/* beachtet werden */
	int	freq;						/* Frequenz in MHz */
	char	freq2;					/* 2. Frequenz (SIGMA Legend II) */
	char	low_res;					/* halbe Pixelrate */
										/* Bit 2: Erweiterungsbit fr h_total */
	UBYTE	r_3c2;					/* Register 3c2 */
	UBYTE	r_3d4[25];				/* Register 3d4, Index 0 bis $18 */
	UBYTE	extended[3];			/* Register 3d4, Index $33 bis $35 */
} RESOLUTION;

/* alle Zeiger auf Routinen erwarten ihre Parameter im */
/* Turbo-/Pure-C-Format: WORD-Parameter in ihrer Reihenfolge in */
/* den Registern d0-d2, Zeiger in den Registern a0-a1 */
typedef struct
{
												/* Versionsnummer in ASCII */
	LONG	id;								/* erst ab Version 1.37 */
												/* Zeiger auf Routine zur  */
												/* Auflsungsumschaltung */
	VOID	(*p_chres)(RESOLUTION *res);
	WORD	mode;								/* Auflsungstyp: */
												/* 0: 16 Farben */
												/* 1: 2 Farben */
												/* 2: 256 Farben */
												/* 3: 32768 Farben (Intelformat) */
												/* 4: 65536 Farben (Intelformat) */
												/*	5: 16.7 Mio. (24 Bit BGR) */
												/* 6: 16.7 Mio. (32 Bit RGBx) */
	WORD	bypl;								/* Bytes pro Bildschirmzeile */
	WORD	planes;							/* Anzahl Bildschirmplanes: */
												/* 1, 4, 8, 16 oder 24*/
	WORD	colors;							/* Anzahl Farben (VDI-Wert) */
	WORD	hc;								/* Hardcopymodus: */
												/* 0: 1 Bildpxl. = 1x1 Druckpxl. */
												/* 1: 1 Bildpxl. = 2x2 Druckpxl. */
												/* 2: 1 Bildpxl. = 4x4 Druckpxl. */
	WORD	max_x, max_y;					/* Bildschirmauflsung */
												/* fr virtuelle Bildschirm- */
												/* verwaltung: */
	WORD	rmn_x, rmx_x;					/* physikalisch auf dem Monitor */
	WORD	rmn_y, rmx_y;					/* dargestellter Bereich */

	UBYTE	*scr_base;						/* Zeiger auf physikalische */
												/* Bildschirmadresse */
	UBYTE	*reg_base;						/* Zeiger auf I/O-Adressen */
	BYTE	name[36];						/* Name der aktuellen Auflsung */

	LONG	bl_count;						/* Zhler fr Dunkelschaltung */
												/* Startwert fr Zhler in */
	LONG	bl_max;							/* 1/200stel Sekunden */
	WORD	bl_on;							/* != 0: Bildschirm ist dunkel */
	
	WORD	card;								/* Graphikkartentyp */
	UBYTE	speed_tab[12];					/* Maus-Beschleunigungstabelle */

												/* virtuelle Bildschirmverwaltung: */
												/* es wird getestet, ob der Punkt */
												/* (x;y) sich im dargestellten */
												/* Bildabschnitt befindet */
												/* falls nicht, wird der darge- */
												/* stellte Abschnitt so verschoben, */
												/* da der Punkt gerade sichtbar */
												/* wird */
	VOID	(*chng_vrt)(WORD x, WORD y);
	WORD	boot_drv;						/* Laufwerk, von dem der Nova- */
												/* Treiber gestartet wurde */
												/* Hier befindet sich auch die */
												/* Auflsungsdatei (im AUTO-Ordner) */

	LONG	(*set_vec)(VOID);				/* Ausgabevektoren neu setzen */
												/* mu im Supervisormodus auf- */
												/* gerufen werden */

	VOID	*main_work;						/* Zeiger auf 1. VDI-Wkst. */
	WORD	(*handler)(WORD x, LONG y);/* Zeiger auf Funktionshandler */
												/* ebenfalls im Supervisormodus */
												/* aufrufen */
	VOID	(*init_col)(VOID);			/* Zeiger auf Farbinitialisierung */
	UWORD	scrn_cnt;						/* Anzahl Bildschirme */
	LONG	scrn_sze;						/* Gre eines Bildschirms in Bytes */
	VOID	*base;							/* Adresse von Bildschirmseite 0 */
	VOID	(*p_setscr)(VOID *adr);		/* Zeiger auf Routine, die */
												/* neue physikalische Bildschirm- */
												/* adresse setzt */
	WORD	v_top, v_bottom,				/* Rnder fr virt. Speicherverwaltung */
			v_left, v_right;
	WORD	max_light;						/* Anzahl Helligkeitsstufen */
												/* Bildlage verndern */
												/* res: Auflsungsstruktur */
												/* direction = 0: hor. Lage ndern */
												/* direction != 0: ver. Lage ndern */
												/* offset: Anzahl Einheiten, um die */
												/*        verschoben werden soll */
												/*        bei links oder oben positiv */
	VOID	(*chng_pos)(RESOLUTION *res, WORD direction, WORD offset);
	VOID	(*chng_edg)(WORD *edge);	/* virt. Rnder setzen */
	WORD	hw_flags;						/* Hardwareflags */
	WORD	calib_on;						/* Flag fr Kalibrierung */
	WORD	calib_col[6][3];				/* Kalibrierungsfarben */
	VOID	(*calib_in)(VOID);			/* Initialisierung der Kalibrierung */
	BYTE	*cal_tab;
	BYTE	*recal_tab;
} ICB;


#endif